<?php
declare(strict_types=1);

namespace Catequil\Invoice\Handler;

use Catequil\Core\Mapping\Route;
use Catequil\Invoice\Service\InvoiceServiceInterface;
use Laminas\Diactoros\Response\JsonResponse;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\RequestHandlerInterface;
use stdClass;

/**
 * Class UploadInvoice
 *
 * @package Catequil\Invoice\Handler
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-invoice
 */
#[Route('/invoice/upload', 'POST', 'invoice.upload')]
final class UploadInvoice implements RequestHandlerInterface
{
    private InvoiceServiceInterface $invoices;

    /**
     * @param InvoiceServiceInterface $invoices
     */
    public function __construct(InvoiceServiceInterface $invoices)
    {
        $this->invoices = $invoices;
    }

    /**
     * @param ServerRequestInterface $request
     * @return ResponseInterface
     */
    public function handle(ServerRequestInterface $request): ResponseInterface
    {
        $this->invoices->uploadFromGath(
            $request->getParsedBody()
        );

        return new JsonResponse(
            new stdClass
        );
    }
}