<?php
declare(strict_types=1);

namespace Catequil\Invoice\Hydrator;

use Laminas\Hydrator\NamingStrategy\MapNamingStrategy;
use Laminas\Hydrator\ReflectionHydrator;

/**
 * Class InvoiceAddressHydrator
 *
 * @package Catequil\Invoice\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-invoice
 */
final class InvoiceAddressHydrator extends ReflectionHydrator
{
    public function __construct()
    {
        $this->setNamingStrategy(
            MapNamingStrategy::createFromAsymmetricMap([], [
                'Ime' => 'firstName',
                'Prezime' => 'lastName',
                'NazivFirme' => 'companyName',
                'Adresa1' => 'address1',
                'Adresa2' => 'address2',
                'Grad' => 'city',
                'Posta' => 'postCode',
                'Drzava' => 'country',
                'Email' => 'emailAddress',
                'Telefon' => 'phoneNumber',
            ])
        );
    }
}