<?php
declare(strict_types=1);

namespace Catequil\Invoice\Hydrator;

use Laminas\Hydrator\NamingStrategy\MapNamingStrategy;
use Laminas\Hydrator\ReflectionHydrator;

/**
 * Class InvoiceItemHydrator
 *
 * @package Catequil\Invoice\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-invoice
 */
final class InvoiceItemHydrator extends ReflectionHydrator
{
    public function __construct()
    {
        $this->setNamingStrategy(
            MapNamingStrategy::createFromAsymmetricMap([], [
                'RedniBroj' => 'sortNo',
                'Code' => 'sku',
                'Naziv' => 'name',
                'Kol' => 'quantity',
                'CijenaM' => 'regularPrice',
                'IzlRabat' => 'rebate',
                'FaktCijenaM' => 'price',
                'Ukupno' => 'total',
            ])
        );
    }
}