<?php
declare(strict_types=1);

namespace Catequil\Invoice\Hydrator;

use Laminas\Hydrator\NamingStrategy\MapNamingStrategy;
use Laminas\Hydrator\ReflectionHydrator;

/**
 * Class InvoicePaymentHydrator
 *
 * @package Catequil\Invoice\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-invoice
 */
final class InvoicePaymentHydrator extends ReflectionHydrator
{
    public function __construct()
    {
        $this->setNamingStrategy(
            MapNamingStrategy::createFromAsymmetricMap([], [
                'Opis' => 'description',
                'Iznos' => 'amount',
            ])
        );
    }
}