<?php
declare(strict_types=1);

namespace Catequil\Invoice\Model;

use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\JoinColumn;
use Doctrine\ORM\Mapping\ManyToOne;
use Doctrine\ORM\Mapping\Table;

/**
 * Class InvoiceOrder
 *
 * @package Catequil\Invoice\Model
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-invoice
 */
#[Entity]
#[Table('invoice_order')]
class InvoiceOrder implements InvoiceOrderInterface
{
    #[Id]
    #[GeneratedValue('AUTO')]
    #[Column(type: Types::BIGINT, options: ['unsigned' => true])]
    protected ?int $id = null;
    #[ManyToOne(Invoice::class, inversedBy: 'orders')]
    #[JoinColumn(nullable: false, onDelete: 'CASCADE')]
    protected InvoiceInterface $invoice;
    #[Column(type: Types::BIGINT)]
    protected int $orderNo;

    /**
     * @return int
     */
    public function getOrderNo(): int
    {
        return $this->orderNo;
    }
}