<?php
declare(strict_types=1);

namespace Catequil\Invoice\Model;

use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\JoinColumn;
use Doctrine\ORM\Mapping\ManyToOne;
use Doctrine\ORM\Mapping\Table;

/**
 * Class InvoicePayment
 *
 * @package Catequil\Invoice\Model
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-invoice
 */
#[Entity]
#[Table('invoice_payment', options: ['collate' => 'utf8mb4_croatian_ci'])]
class InvoicePayment implements InvoicePaymentInterface
{
    //<editor-fold desc="Entity Fields">

    #[Id]
    #[GeneratedValue('AUTO')]
    #[Column(type: Types::BIGINT, options: ['unsigned' => true])]
    protected int $id;
    #[ManyToOne(InvoiceInterface::class, inversedBy: 'payments')]
    #[JoinColumn(nullable: false)]
    protected InvoiceInterface $invoice;
    #[Column(type: Types::STRING)]
    protected string $description;
    #[Column(type: Types::FLOAT)]
    protected float $amount;

    //</editor-fold>
    //<editor-fold desc="Getters & Setters">

    public function getAmount(): float
    {
        return $this->amount;
    }

    public function getDescription(): string
    {
        return $this->description;
    }

    //</editor-fold>
}