<?php
declare(strict_types=1);

namespace CatequilTest\Invoice\Hydrator;

use Catequil\Invoice\Hydrator\InvoicePaymentHydrator;
use Catequil\Invoice\Model\InvoicePayment;
use Catequil\Invoice\Model\InvoicePaymentInterface;
use Laminas\Hydrator\HydratorInterface;
use PHPUnit\Framework\TestCase;
use function file_get_contents;
use function json_decode;

/**
 * Class InvoicePaymentHydratorTest
 *
 * @package CatequilTest\Invoice\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-invoice
 */
final class InvoicePaymentHydratorTest extends TestCase
{
    private HydratorInterface $hydrator;

    protected function setUp(): void
    {
        parent::setUp();
        $this->hydrator = new InvoicePaymentHydrator();
    }

    public function testCanHydrateInvoicePayment()
    {
        $data = json_decode(file_get_contents(__DIR__ . '/../data/invoice1.json'), true);
        $data = $data['NacinPlacanja'][0];

        /** @var InvoicePaymentInterface $payment */
        $payment = $this->hydrator->hydrate($data, new InvoicePayment());

        self::assertEquals('KRED.KART WS Corvus', $payment->getDescription());
        self::assertEquals(319.88, $payment->getAmount());
    }
}